; Title - BAVE Bank $20 - Splash Screen

INCLUDE "HVGLIB.H"			; Home Video Game Library Header
INCLUDE	"bave.h"			; include file for bave routines

	FIRSTRRGLINE	EQU		70
	LASTRRGLINE		EQU		159

	ORG	$3000				; starting addy of additional banks

	DI
	LD	A,1<<RAST_CUSTOM + $20	; this bank
	LD	(RasterBank),A		; bank 0, custom raster
	LD	A,RRGRasters>>8
	LD	(RasterCode+1),A
	LD	A,RRGRasters & $ff
	LD	(RasterCode),A

	LD	A,FIRSTRRGLINE
	LD	(RasterTemp),A		; temp var used for "blood red" line
	EI

	; set colors on right side of screen (greyscale)
	LD	A,0
	OUT  (COL0R),A
	INC	A
	INC	A
	OUT  (COL1R),A
	INC	A
	INC	A
	OUT	(COL2R),A
	INC	A
	INC	A
	OUT	(COL3R),A

	; add logic hook
	LD	A,1<<LOGIC_CUSTOM + $20	; this bank
	LD	(CustBank),A
	LD	A,RRGLogic>>8
	LD	(CustLogic+1),A
	LD	A,RRGLogic & $ff
	LD	(CustLogic),A
	
	; copy riffraff graphic to screen area
	LD	HL,rrgames
	LD	DE,$4000
	LD	BC,40*90
	LDIR

	RET
; ----------------------------------------------------------------
RRGLogic:
;	IN	A,(POT0)		; Get Pot 0 value (Player 1 knob)
;	XOR	$ff
;	LD	(ShowB1),A
;	OUT	(COL3L),A		; put pot value in color 3 left
	
	LD	A,(RasterTemp)
	CP	LASTRRGLINE
	JR	C,RRGL1		; don't allow trigger to advance until entire name has been shown

	LD	HL,RRGL3	; this code is kinda janky.. using hook to call CheckDTrigger.
	PUSH HL			; A cleaner method of calling engine routines should be possible
	XOR	A			; simply by having the ability to export labels of some sort
	LD	HL,(BAVE_TESTD)
	JP	(HL)
RRGL3:
	JR	Z,RRGL1		; wait for trigger to start browser init

	; turn on browser
	LD	HL,RRGL2
	PUSH HL
	LD	HL,(BAVE_BROWSE)
	JP (HL)
RRGL2:	; started debugger
	RET

RRGL1:
	RET
; ----------------------------------------------------------------
RRGBreaks:
	DB	181		; bottom of screen (start of vblank)
	DB	67		; start of riffraffgames text
	DB	100		; end of red (set by code)
; ----------------------------------------------------------------
RRGBands:
	DB	$00,$a1,$96,$ae	; shades of neon green
	DB	$00,$70,$51,$61 ; reds for riffraff games
	DB	$00,$00,$00,$00 ; black-out
;	DB	$00,$d8,$dc,$eb	; shades of blue
	; ----------------------------------------------------------------
RRGRasters:
	LD	A,(CurrentIntLine)
	ADD	A,A
	ADD	A,A
	LD	C,A
	LD	B,0
	LD	HL,RRGBands
	ADD	HL,BC
	LD	A,(HL)
	OUT  (COL0L),A		; left Color Register 0
	INC	HL
	LD	A,(HL)
	OUT  (COL1L),A		; left Color Register 1
	INC	HL
	LD	A,(HL)
	OUT  (COL2L),A		; left Color Register 2
	INC	HL
	LD	A,(HL)
	OUT  (COL3L),A		; left Color Register 3

	LD	A,(CurrentIntLine)
	CP	0
	JR	NZ,RRGR1
; first line in table, placed at bottom of screen in vblank area
	LD	A,1
	LD (VBlankHit),A	; signal "vblank" to sync main game code
	; set split for colors
	LD	A,25			; horizontal split between riffraffgames and picture
	OUT	(HORCB),A

RRGR1:
	; get to next line
	LD	A,(CurrentIntLine)
	INC A
	CP	3
	JR	C,RRGR2
	XOR	A
RRGR2:
	LD	(CurrentIntLine),A
	JR	Z,DoneMoving
	CP	2
	JR	NZ,RRGR3			; in the riffraffgames section.. next section turns colors black
	LD	A,(RasterTemp)
	CP	LASTRRGLINE			; as far down as "red band" goes
	JR	NC,DoneMoving
	INC	A
	LD	(RasterTemp),A
DoneMoving:
	OUT	(INLIN),A
	JP	RASTEND
RRGR3:
	LD	C,A
	LD	B,0
	LD	HL,RRGBreaks
	ADD	HL,BC
	LD	A,(HL)			; get next line to interrupt on
	OUT (INLIN),A		; ($0f)
	JP	RASTEND
; ----------------------------------------------------------------
INCLUDE "rrgames.h"			; riffraffgames splash screen image
; ----------------------------------------------------------------

EndOfModule:
	DB	0

	ORG	$3f7e
	DW EndOfModule

	ORG $3fff
	DB 0
